diff -u -r icu/source/i18n/repattrn.cpp icu.new/source/i18n/repattrn.cpp
--- icu/source/i18n/repattrn.cpp	2004-12-30 07:25:50.000000000 +0000
+++ icu.new/source/i18n/repattrn.cpp	2006-08-10 00:52:09.000000000 +0100
@@ -57,6 +57,11 @@
 //    Assignmenet Operator
 //
 //--------------------------------------------------------------------------
+static void copyStringTok(UHashTok *a, UHashTok *b)
+{
+  a->pointer = new UnicodeString (*(UnicodeString *)b->pointer);
+}
+
 RegexPattern &RegexPattern::operator = (const RegexPattern &other) {
     if (this == &other) {
         // Source and destination are the same.  Don't do anything.
@@ -91,6 +96,8 @@
     //  Copy the pattern.  It's just values, nothing deep to copy.
     fCompiledPat->assign(*other.fCompiledPat, fDeferredStatus);
     fGroupMap->assign(*other.fGroupMap, fDeferredStatus);
+    fNamedGroups->assign(*other.fNamedGroups, (UTokenAssigner *)copyStringTok, fDeferredStatus);
+    fNamedGroupMap->assign(*other.fNamedGroupMap, fDeferredStatus);
 
     //  Copy the Unicode Sets.  
     //    Could be made more efficient if the sets were reference counted and shared,
@@ -135,6 +142,8 @@
     fFrameSize        = 0;
     fDataSize         = 0;
     fGroupMap         = NULL;
+    fNamedGroups      = NULL;
+    fNamedGroupMap    = NULL;
     fMaxCaptureDigits = 1;  
     fStaticSets       = NULL;
     fStaticSets8      = NULL;
@@ -147,14 +156,16 @@
     
     fCompiledPat      = new UVector32(fDeferredStatus);
     fGroupMap         = new UVector32(fDeferredStatus);
+    fNamedGroups      = new UVector(fDeferredStatus);
+    fNamedGroupMap    = new UVector32(fDeferredStatus);
     fSets             = new UVector(fDeferredStatus);
     fInitialChars     = new UnicodeSet;
     fInitialChars8    = new Regex8BitSet;
     if (U_FAILURE(fDeferredStatus)) {
         return;
     }
-    if (fCompiledPat == NULL  || fGroupMap == NULL || fSets == NULL ||
-        fInitialChars == NULL || fInitialChars8 == NULL) {
+    if (fCompiledPat == NULL  || fGroupMap == NULL || fNamedGroups == NULL || fNamedGroupMap == NULL
+        || fSets == NULL || fInitialChars == NULL || fInitialChars8 == NULL) {
         fDeferredStatus = U_MEMORY_ALLOCATION_ERROR;
         return;
     }
@@ -186,6 +197,17 @@
     fSets8 = NULL;
     delete fGroupMap;
     fGroupMap = NULL;
+    delete fNamedGroupMap;
+    fNamedGroupMap = NULL;
+    for (i = 0; i < fNamedGroups->size(); ++i) {
+      UnicodeString *s;
+      s = (UnicodeString *)fNamedGroups->elementAt(i);
+      if (s != NULL) {
+          delete s;
+      }
+    }
+    delete fNamedGroups;
+    fNamedGroups = NULL;
     delete fInitialChars;
     fInitialChars = NULL;
     delete fInitialChars8;
@@ -404,6 +426,95 @@
 
 //---------------------------------------------------------------------
 //
+//   getGroupNames
+//
+//---------------------------------------------------------------------
+int32_t RegexPattern::getGroupNames(int32_t        startIndex,
+                                    UnicodeString  dest[],
+                                    int32_t        destCapacity,
+                                    UErrorCode     &status) {
+    if (U_FAILURE(status)) {
+        return 0;
+    }
+
+    int32_t count = fNamedGroups->size();
+
+    if (!destCapacity)
+        return count;
+
+    if (startIndex >= count) {
+        // This is not an error, the intention being that users of this
+        // method can write something like this:
+        //
+        //    UnicodeString names[10];
+        //    int32_t count, index;
+        //
+        //    while ((count = pattern->getGroupNames(index, names, 10, &status))
+        //           && U_SUCCESS(status)) {
+        //      ...
+        //      index += count;
+        //    }
+        return 0;
+    }
+
+    count -= startIndex;
+    if (count > destCapacity)
+        count = destCapacity;
+
+    int32_t n;
+    for (n = 0; n < count; ++n) {
+        dest[n] = *(UnicodeString *)fNamedGroups->elementAt(n + startIndex);
+    }
+
+    return count;
+}
+
+
+
+
+
+//---------------------------------------------------------------------
+//
+//   groupIndexFromName
+//
+//---------------------------------------------------------------------
+int32_t RegexPattern::groupIndexFromName(const UnicodeString &groupName,
+                                         UErrorCode          &status) const {
+    if (U_FAILURE(status)) {
+        return 0;
+    }
+
+    int32_t namedGroupCount = fNamedGroups->size();
+    int32_t nameIndex;
+    for (nameIndex = 0; nameIndex < namedGroupCount; ++nameIndex) {
+        UnicodeString *name = (UnicodeString *)fNamedGroups->elementAt(nameIndex);
+
+        if (*name == groupName) {
+            return fNamedGroupMap->elementAti(nameIndex) + 1;
+        }
+    }
+
+    status = U_REGEX_UNKNOWN_GROUP_NAME;
+    return -1;
+}
+
+
+
+
+//---------------------------------------------------------------------
+//
+//   groupCount
+//
+//---------------------------------------------------------------------
+int32_t RegexPattern::groupCount() const {
+    return fGroupMap->size();
+}
+
+
+
+
+//---------------------------------------------------------------------
+//
 //   split
 //
 //---------------------------------------------------------------------
@@ -443,6 +554,7 @@
     REGEX_DUMP_DEBUG_PRINTF(("%4d   %08x    %-15s  ", index, op, opNames[pinnedType]));
     switch (type) {
     case URX_NOP:
+    case URX_STATE_POP:
     case URX_DOTANY:
     case URX_DOTANY_ALL:
     case URX_DOTANY_PL:
@@ -458,6 +570,7 @@
         // Types with no operand field of interest.
         break;
         
+    case URX_CONDITION:
     case URX_RESERVED_OP:
     case URX_START_CAPTURE:
     case URX_END_CAPTURE:
@@ -551,7 +664,6 @@
 }
 #endif
 
-
 #if defined(REGEX_DEBUG)
 U_CAPI void  U_EXPORT2 
 RegexPatternDump(const RegexPattern *This) {
diff -u -r icu/source/i18n/unicode/regex.h icu.new/source/i18n/unicode/regex.h
--- icu/source/i18n/unicode/regex.h	2005-06-23 00:38:06.000000000 +0100
+++ icu.new/source/i18n/unicode/regex.h	2006-08-10 14:46:25.000000000 +0100
@@ -16,7 +16,7 @@
 #ifndef REGEX_H
 #define REGEX_H
 
-//#define REGEX_DEBUG
+// #define REGEX_DEBUG
 
 /**
  * \file
@@ -329,6 +329,48 @@
 
 
     /**
+     *   Fills in a list of the named groups present in this regular expression,
+     *   returning the number of groups in the list.  Each call will fetch up
+     *   to destCapacity elements starting at startIndex.  If the method is
+     *   called with destCapacity equal to zero, it returns the total number of
+     *   elements that can be fetched.
+     *
+     *   @param startIndex  The first index to fetch.
+     *   @param dest        An array of UnicodeStrings to receive the results.
+     *   @param destCapacity  The number of elements in the destination array.
+     *   @param status      A reference to a UErrorCode to receive any errors.
+     *   @return            The number of elements in the destination array
+     *                      that were used to hold names, *or*, if destCapacity
+     *                      is zero, the total number of available elements.
+     *
+     */
+    virtual int32_t getGroupNames(int32_t       startIndex,
+                                  UnicodeString dest[],
+                                  int32_t       destCapacity,
+                                  UErrorCode    &status);
+
+
+   /**
+    *   Returns the group index for the named group with the specified name.
+    *
+    *   @param groupName    the capture group name
+    *   @param  status      A reference to a UErrorCode to receive any errors.
+    *
+    *   @return the index of the group, or a -ve number to indicate failure.
+    *
+    */
+    virtual int32_t groupIndexFromName(const UnicodeString &groupName,
+                                       UErrorCode &status) const;
+
+
+   /**
+    *   Returns the number of capturing groups in this pattern.
+    *   @return the number of capture groups
+    */
+    virtual int32_t groupCount() const;
+
+
+    /**
      * Split a string into fields.  Somewhat like split() from Perl.
      * The pattern matches identify delimiters that separate the input
      *  into fields.  The input data between the matches becomes the
@@ -405,6 +447,9 @@
 
     UVector32       *fGroupMap;    // Map from capture group number to position of
                                    //   the group's variables in the matcher stack frame.
+    UVector         *fNamedGroups; // A vector of group names.
+    UVector32       *fNamedGroupMap; // Map from name index to position of the group's
+                                   // variables in the matcher stack
 
     int32_t         fMaxCaptureDigits;
 
@@ -622,6 +667,35 @@
 
 
    /**
+    *    Returns a string containing the text captured by the given group
+    *    during the previous match operation.
+    *
+    *    @param groupName    the capture group name
+    *    @param   status     A reference to a UErrorCode to receive any errors.
+    *                        Possible errors are  U_REGEX_INVALID_STATE if no match
+    *                        has been attempted or the last match failed and
+    *                        U_REGEX_UNKNOWN_GROUP_NAME for a bad capture group name.
+    *    @return the captured text
+    */
+    virtual UnicodeString group(const UnicodeString &groupName,
+                                UErrorCode &status) const;
+
+   /**
+    *   Returns the group index for the named group with the specified name.
+    *   Actually calls the similarly named method on the RegexPattern object;
+    *   this method is only provided because of the presence of groupCount()
+    *   on the matcher.
+    *
+    *   @param groupName    the capture group name
+    *   @param  status      A reference to a UErrorCode to receive any errors.
+    *
+    *   @return the index of the group, or a -ve number to indicate failure.
+    *
+    */
+    virtual int32_t groupIndexFromName(const UnicodeString &groupName,
+                                       UErrorCode &status) const;
+
+   /**
     *   Returns the number of capturing groups in this matcher's pattern.
     *   @return the number of capture groups
     *   @stable ICU 2.4
@@ -656,6 +730,22 @@
 
 
    /**
+    *   Returns the index in the input string of the start of the text matched by the
+    *    specified capture group during the previous match operation.  Return -1 if
+    *    the capture group exists in the pattern, but was not part of the last match.
+    *
+    *    @param  groupName   the capture group name
+    *    @param  status      A reference to a UErrorCode to receive any errors.  Possible
+    *                        errors are  U_REGEX_INVALID_STATE if no match has been
+    *                        attempted or the last match failed, and
+    *                        U_REGEX_UNKNOWN_GROUP_NAME for a bad capture group number
+    *    @return the start position of substring matched by the specified group.
+    */
+    virtual int32_t start(const UnicodeString &groupName,
+                          UErrorCode &status) const;
+
+
+   /**
     *    Returns the index in the input string of the first character following the
     *    text matched during the previous match operation.
     *   @param   status      A reference to a UErrorCode to receive any errors.  Possible
@@ -684,6 +774,21 @@
 
 
    /**
+    *    Returns the index in the input string of the character following the
+    *    text matched by the specified capture group during the previous match operation.
+    *    @param groupName    the capture group name
+    *    @param   status      A reference to a UErrorCode to receive any errors.  Possible
+    *                        errors are  U_REGEX_INVALID_STATE if no match has been
+    *                        attempted or the last match failed and
+    *                        U_REGEX_UNKNOWN_GROUP_NAME for a bad capture group number
+    *    @return  the index of the first character following the text
+    *              captured by the specifed group during the previous match operation.
+    *              Return -1 if the capture group exists in the pattern but was not part of the match.
+    */
+    virtual int32_t end(const UnicodeString &groupName, UErrorCode &status) const;
+
+
+   /**
     *   Resets this matcher.  The effect is to remove any memory of previous matches,
     *       and to cause subsequent find() operations to begin at the beginning of
     *       the input string.
diff -u -r icu/source/i18n/unicode/uregex.h icu.new/source/i18n/unicode/uregex.h
--- icu/source/i18n/unicode/uregex.h	2005-06-28 23:23:06.000000000 +0100
+++ icu.new/source/i18n/unicode/uregex.h	2006-08-09 01:24:26.000000000 +0100
@@ -332,7 +332,8 @@
 uregex_groupCount(URegularExpression *regexp,
                   UErrorCode         *status);
 
-/** Extract the string for the specified matching expression or subexpression.
+/**
+  * Extract the string for the specified matching expression or subexpression.
   * Group #0 is the complete string of matched text.
   * Group #1 is the text matched by the first set of capturing parentheses.
   *
@@ -355,6 +356,56 @@
              int32_t             destCapacity,
              UErrorCode          *status);
 
+/**
+ *    Returns the group index for the named group with the specified name,
+ *    provided that the named group was matched by the regular expression.
+ *
+ *    @param   regexp       The compiled regular expression.
+ *    @param   name         The capture group name.
+ *    @param   status       A reference to a UErrorCode to receive any errors.
+ *    @return               The index of the corresponding numbered group.
+ *                          If there is no group with the specified name,
+ *                          -1 is returned with U_REGEX_UNKNOWN_GROUP_NAME in
+ *                          status.
+ */
+U_DRAFT int32_t U_EXPORT2
+uregex_groupIndexFromName(URegularExpression *regexp,
+                          const UChar        *name,
+                          int32_t            nameLen,
+                          UErrorCode         *status);
+
+
+/**
+ *    Returns the number of named groups in this regular expression.
+ *
+ *    @param   regexp       The compiled regular expression.
+ *    @return               A count of the named groups in this regexp.
+ */
+U_DRAFT int32_t U_EXPORT2
+uregex_namedGroupCount(URegularExpression *regexp,
+                       UErrorCode         *status);
+
+
+
+/**
+ *    Returns the name of the specified named group.
+ *
+ *    @param   regexp       The compiled regular expression.
+ *    @param   namedGrpNum  The index of the named group, in the range 0
+ *                          to uregex_namedGroupCount().
+ *    @param   dest         Buffer to receive the matching string data
+ *    @param   destCapacity Capacity of the dest buffer.
+ *    @param   status       A reference to a UErrorCode to receive any errors.
+ *    @return               The length of the name, or zero on failure.
+ */
+U_DRAFT int32_t U_EXPORT2
+uregex_namedGroupName(URegularExpression *regexp,
+                      int32_t            namedGrpNum,
+                      UChar              *dest,
+                      int32_t            destCapacity,
+                      UErrorCode         *status);
+
+
 
 /**
   *   Returns the index in the input string of the start of the text matched by the
diff -u -r icu/source/i18n/uregex.cpp icu.new/source/i18n/uregex.cpp
--- icu/source/i18n/uregex.cpp	2005-06-21 17:54:40.000000000 +0100
+++ icu.new/source/i18n/uregex.cpp	2006-08-09 01:29:20.000000000 +0100
@@ -432,6 +432,79 @@
 
 //------------------------------------------------------------------------------
 //
+//    uregex_groupIndexFromName
+//
+//------------------------------------------------------------------------------
+U_CAPI int32_t U_EXPORT2
+uregex_groupIndexFromName(URegularExpression *regexp,
+                          const UChar        *name,
+                          int32_t            nameLen,
+                          UErrorCode         *status) {
+    if (validateRE(regexp, status) == FALSE) {
+        return NULL;
+    }
+    if (name == NULL || nameLen < -1) {
+        *status = U_ILLEGAL_ARGUMENT_ERROR;
+        return NULL;
+    }
+
+    // Make a read-only-aliased copy of the name string.
+    UnicodeString nameString(nameLen == -1, name, nameLen);
+
+    return regexp->fMatcher->groupIndexFromName(nameString, *status);
+}
+
+
+//------------------------------------------------------------------------------
+//
+//    uregex_namedGroupCount
+//
+//------------------------------------------------------------------------------
+U_CAPI int32_t U_EXPORT2
+uregex_namedGroupCount(URegularExpression *regexp,
+                       UErrorCode         *status)
+{
+    if (validateRE(regexp, status) == FALSE) {
+        return 0;
+    }
+    int32_t result = regexp->fPat->getGroupNames(0, NULL, 0, *status);
+    return result;
+}
+
+
+//------------------------------------------------------------------------------
+//
+//    uregex_namedGroupName
+//
+//------------------------------------------------------------------------------
+U_CAPI int32_t U_EXPORT2
+uregex_namedGroupName(URegularExpression *regexp,
+                      int32_t            namedGrpNum,
+                      UChar              *dest,
+                      int32_t            destCapacity,
+                      UErrorCode         *status)
+{
+    if (validateRE(regexp, status) == FALSE) {
+        return 0;
+    }
+    if (destCapacity < 0 || (destCapacity > 0 && dest == NULL)) {
+        *status = U_ILLEGAL_ARGUMENT_ERROR;
+        return 0;
+    }
+
+    UnicodeString name;
+    int32_t result = regexp->fPat->getGroupNames(namedGrpNum, &name, 1, *status);
+
+    if (U_FAILURE(*status)) {
+        return 0;
+    }
+
+    return name.extract(dest, destCapacity, *status);
+}
+
+
+//------------------------------------------------------------------------------
+//
 //    uregex_start
 //
 //------------------------------------------------------------------------------
diff -u -r icu/source/test/cintltst/reapits.c icu.new/source/test/cintltst/reapits.c
--- icu/source/test/cintltst/reapits.c	2004-12-16 02:54:24.000000000 +0000
+++ icu.new/source/test/cintltst/reapits.c	2006-08-09 01:33:45.000000000 +0100
@@ -531,6 +531,69 @@
     }
 
     /*
+     *  groupIndexFromName()
+     */
+    {
+        UChar   text1[80];
+        UChar   buf[80];
+        UBool   result;
+        int32_t groupIndex;
+        int32_t count;
+
+        u_uastrncpy(text1, "noise abc interior def, and this is off the end",  sizeof(text1)/2);
+        
+        status = U_ZERO_ERROR;
+        re = uregex_openC("(?:abc(?P<foo>.*?)def|(?P<bar>ergodic))",
+                          0, NULL, &status);
+        TEST_ASSERT_SUCCESS(status);
+
+        uregex_setText(re, text1, -1, &status);
+        result = uregex_find(re, 0, &status);
+        TEST_ASSERT(result == TRUE);
+
+        status = U_ZERO_ERROR;
+        count = uregex_namedGroupCount(re, &status);
+        TEST_ASSERT_SUCCESS(status);
+        TEST_ASSERT(count == 2);
+
+        /* Check that extracting group names works */
+        status = U_ZERO_ERROR;
+        count = uregex_namedGroupName(re, 0, buf, sizeof(buf) / 2, &status);
+        TEST_ASSERT_SUCCESS(status);
+        TEST_ASSERT_STRING("foo", buf, TRUE);
+        TEST_ASSERT(count == 3);
+
+        status = U_ZERO_ERROR;
+        count = uregex_namedGroupName(re, 1, buf, sizeof(buf) / 2, &status);
+        TEST_ASSERT_SUCCESS(status);
+        TEST_ASSERT_STRING("bar", buf, TRUE);
+        TEST_ASSERT(count == 3);
+
+        /* Capture group "foo".  Should succeed and return 1. */
+        status = U_ZERO_ERROR;
+        u_uastrncpy(buf, "foo", sizeof(buf)/2);
+        groupIndex = uregex_groupIndexFromName(re, buf, -1, &status);
+        TEST_ASSERT_SUCCESS(status);
+        TEST_ASSERT(groupIndex == 1);
+
+        /* Capture group "bar".  Should succeed and return 2. */
+        status = U_ZERO_ERROR;
+        u_uastrncpy(buf, "bar", sizeof(buf)/2);
+        groupIndex = uregex_groupIndexFromName(re, buf, -1, &status);
+        TEST_ASSERT_SUCCESS(status);
+        TEST_ASSERT(groupIndex == 2);
+
+        /* Capture group "pants".  Should fail. */
+        status = U_ZERO_ERROR;
+        u_uastrncpy(buf, "pants", sizeof(buf)/2);
+        groupIndex = uregex_groupIndexFromName(re, buf, -1, &status);
+        TEST_ASSERT(status == U_REGEX_UNKNOWN_GROUP_NAME);
+        TEST_ASSERT(groupIndex == -1);
+
+        uregex_close(re);
+    }
+
+    /*
      *  replaceFirst()
      */
     {
